// Adven.h - Main Header File

#include <IMCUtils.h>
#include <ExgMgr.h>

#include "AppData.h"

/*-------------------------------------------------------------------------*/
// Constants
 
#define MyVersionNum					0x01
#define MyPrefVersionNum				0x01
#define MyPrefID						0x00
#define MyDBName						"AdvnDB"
#define MyDBType						'DATA'
#define CreatorID						'Advn'

// Update hints
#define updateFontChanged				0x10

/*-------------------------------------------------------------------------*/

typedef struct {
	FontID		noteFont;
	UInt8 		bStartNew;	// if true, the game will start new
} MyPreferenceType;

/*-------------------------------------------------------------------------*/
// Global Vars

extern DmOpenRef AppDB;

/*-------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

// From Adven.cpp
void StartNewGame (Int16 index);
FieldPtr GetObjectPtr (UInt16 objectID);
void FldReplaceText (FieldPtr fld, const char* pText);

// From GameList.cpp
Boolean GameListHandleEvent (EventPtr event);

#ifdef __cplusplus 
}
#endif

